import { ApiProperty } from "@nestjs/swagger"
import { MoneyUpdate, MoneyUpdateType } from "@prisma/client"

export class MoneyUpdateEntity implements MoneyUpdate {
  constructor (partial: Partial<MoneyUpdateEntity>) {
    Object.assign(this, partial)
  }

  @ApiProperty({ description: "Identifiant unique de la mise à jour de solde" })
  id: number

  @ApiProperty({ description: "Utilisateur⋅rice concerné⋅e par la mise à jour de solde" })
  userId: number

  @ApiProperty({ description: "Montant de la modification du solde" })
  amount: number

  @ApiProperty({ description: "Type de modification de solde" })
  reason: MoneyUpdateType

  @ApiProperty({ description: "Identifiant de la réalisation de défi, si la mise à jour est liée à un défi", nullable: true })
  actionId: number

  @ApiProperty({ description: "Identifiant du trajet acheté, si la mise à jour est liée à la réservation d'un train", nullable: true })
  tripId: string

  @ApiProperty({ description: "Date et heure de la modification de solde" })
  timestamp: Date
}
